#ifndef _JTOOL_H
#define _JTOOL_H
#include <stdint.h>


typedef enum
{
	dev_all = -1,
	dev_i2c = 0,
	dev_io,
	dev_spi,
	dev_can,
	dev_max,
}dev_type_enum;

typedef enum
{
	ErrNone = 0,//ɹ
	ErrParam = 1 << 0,//
	ErrDisconnect = 1 << 1,//USB Ͽ
	ErrBusy = 1 << 2,//USBæ
	ErrWaiting = 1 << 3,//ڵȴظ
	ErrTimeOut = 1 << 4,//ͨųʱ
	ErrDataParse = 1 << 5,//ͨݴ
	ErrFailACK = 1 << 6,//ʧܲ
} ErrorType;

//豸API
extern __declspec(dllexport) char* DevicesScan(int DevType, int* OutCnt);
extern __declspec(dllexport) void* DevOpen(int DevType, char* Sn, int Id);
extern __declspec(dllexport) BOOL DevClose(void* DevHandle);

//JIO API
extern __declspec(dllexport) ErrorType IOSetNone(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType IOSetNone_m(void* DevHandle, uint32_t iomask);
extern __declspec(dllexport) ErrorType IOSetIn(void* DevHandle, uint32_t ionum, BOOL pullup, BOOL pulldown);
extern __declspec(dllexport) ErrorType IOSetIn_m(void* DevHandle, uint32_t iomask, uint32_t pullups, uint32_t pulldowns);
extern __declspec(dllexport) ErrorType IOSetOut(void* DevHandle, uint32_t ionum, BOOL pp);
extern __declspec(dllexport) ErrorType IOSetOut_m(void* DevHandle, uint32_t iomask, uint32_t pps);
extern __declspec(dllexport) ErrorType IOSetVal(void* DevHandle, uint32_t ionum, BOOL val);
extern __declspec(dllexport) ErrorType IOSetVal_m(void* DevHandle, uint32_t iomask, uint32_t vals);
extern __declspec(dllexport) ErrorType IOSetOutWithVal(void* DevHandle, uint32_t ionum, BOOL pp, BOOL val);
extern __declspec(dllexport) ErrorType IOSetOutWithVal_m(void* DevHandle, uint32_t iomask, uint32_t pps, uint32_t vals);
extern __declspec(dllexport) ErrorType IOPulseOn(void* DevHandle, uint32_t ionum, uint32_t freq);
extern __declspec(dllexport) ErrorType IOPulseOn_m(void* DevHandle, uint32_t iomask, uint32_t* freqs);
extern __declspec(dllexport) ErrorType IOPulseOff(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType IOPulseOff_m(void* DevHandle, uint32_t iomask);
extern __declspec(dllexport) ErrorType IOPulseCnt(void* DevHandle, uint32_t ionum, uint32_t cnt, uint32_t freq);
extern __declspec(dllexport) ErrorType IOPulseCnt_m(void* DevHandle, uint32_t iomask, uint32_t* cnts, uint32_t* freqs);
extern __declspec(dllexport) ErrorType IOPulseFreq(void* DevHandle, uint32_t ionum, uint32_t freq);
extern __declspec(dllexport) ErrorType IOPulseFreq_m(void* DevHandle, uint32_t iomask, uint32_t* freqs);

extern __declspec(dllexport) ErrorType PWMSetFreq(void* DevHandle, uint32_t freq);
extern __declspec(dllexport) ErrorType PWMSetOut(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType PWMSetOut_m(void* DevHandle, uint32_t iomask);
extern __declspec(dllexport) ErrorType PWMSetOn(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType PWMSetOn_m(void* DevHandle, uint32_t iomask);
extern __declspec(dllexport) ErrorType PWMSetOff(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType PWMSetOff_m(void* DevHandle, uint32_t iomask);
extern __declspec(dllexport) ErrorType PWMSetDuty(void* DevHandle, uint32_t ionum, uint16_t duty);
extern __declspec(dllexport) ErrorType PWMSetDuty_m(void* DevHandle, uint32_t iomask, uint16_t* dutys);

extern __declspec(dllexport) ErrorType CapSetIn(void* DevHandle, uint32_t ionum);
extern __declspec(dllexport) ErrorType CapClearCnt(void* DevHandle, uint32_t ionum);

extern __declspec(dllexport) ErrorType ADCSetIn(void* DevHandle, uint32_t ionum, BOOL isdiff);
extern __declspec(dllexport) ErrorType ADCSetIn_m(void* DevHandle, uint32_t iomask, uint32_t isdiffs);
extern __declspec(dllexport) ErrorType ADCSetSamp(void* DevHandle, uint32_t samp);

extern __declspec(dllexport) ErrorType IOGetInVal(void* DevHandle, uint32_t ionum, BOOL* val);
extern __declspec(dllexport) ErrorType IOGetInVal_m(void* DevHandle, uint32_t iomask, uint32_t* vals);
extern __declspec(dllexport) ErrorType IOGetPulseRemain(void* DevHandle, uint32_t ionum, uint32_t* remaincnt);
extern __declspec(dllexport) ErrorType IOGetPulseRemain_m(void* DevHandle, uint32_t iomask, uint32_t* remaincnts);
extern __declspec(dllexport) ErrorType CapGetVal(void* DevHandle, uint32_t ionum, uint32_t* freq, uint16_t* duty, uint32_t* pulsecnt);
extern __declspec(dllexport) ErrorType ADCGetVal(void* DevHandle, uint32_t ionum, uint16_t* adval);
extern __declspec(dllexport) ErrorType ADCGetVal_m(void* DevHandle, uint32_t iomask, uint16_t* advals);

extern __declspec(dllexport) ErrorType JIOReboot(void* DevHandle);
extern __declspec(dllexport) ErrorType JIOSetVcc(void* DevHandle, uint8_t val);
extern __declspec(dllexport) ErrorType JIOSetVio(void* DevHandle, uint8_t val);
extern __declspec(dllexport) ErrorType JIOSetHardVersion(void* DevHandle, char* version);
extern __declspec(dllexport) ErrorType JIOSetID(void* DevHandle, uint16_t val);
extern __declspec(dllexport) ErrorType JIOIntoBoot(void* DevHandle);


//JI2C API
typedef enum
{
	REGADDR_NONE = 0,//͵ַ
	REGADDR_8Bit = 1,//8λַ
	REGADDR_16Bit = 2,//16λַ
	REGADDR_24Bit = 3,//24λַ
	REGADDR_32Bit = 4,//32λַ
}REGADDR_TYPE;
extern __declspec(dllexport) ErrorType I2CScan(void* DevHandle, uint8_t* cnt, uint8_t* result);
extern __declspec(dllexport) ErrorType I2CWrite(void* DevHandle, uint8_t slave_addr, REGADDR_TYPE reg_type, uint32_t reg_addr, uint16_t len, uint8_t* data);
extern __declspec(dllexport) ErrorType I2CRead(void* DevHandle, uint8_t slave_addr, REGADDR_TYPE reg_type, uint32_t reg_addr, uint16_t len, uint8_t* buf);
extern __declspec(dllexport) ErrorType I2CReadWithDelay(void* DevHandle, uint8_t slave_addr, REGADDR_TYPE reg_type, uint32_t reg_addr, uint16_t len, uint8_t* buf, uint8_t sr_delay, uint8_t raddr_delay);
extern __declspec(dllexport) ErrorType EEWrite(void* DevHandle, uint8_t base_slave_addr, REGADDR_TYPE reg_type, uint16_t page_size, uint32_t reg_addr, uint32_t len, uint8_t* data);
extern __declspec(dllexport) ErrorType EERead(void* DevHandle, uint8_t base_slave_addr, REGADDR_TYPE reg_type, uint32_t reg_addr, uint32_t len, uint8_t* buf);

extern __declspec(dllexport) ErrorType JI2CReboot(void* DevHandle);
extern __declspec(dllexport) ErrorType JI2CSetVcc(void* DevHandle, uint8_t val);
extern __declspec(dllexport) ErrorType JI2CSetVio(void* DevHandle, uint8_t val);
extern __declspec(dllexport) ErrorType JI2CSetSpeed(void* DevHandle, uint8_t val);
extern __declspec(dllexport) ErrorType JI2CSetHardVersion(void* DevHandle, char* version);
extern __declspec(dllexport) ErrorType JI2CSetID(void* DevHandle, uint16_t val);
extern __declspec(dllexport) ErrorType JI2CIntoBoot(void* DevHandle);
#endif